sub init_pre_initial_screen (byref scr as screentype, byref scores as scorestype, byref options as optionstype, byref ingame as ingametype)

	scr.x=640:scr.y=480
	scr.hx=scr.x*.5:scr.hy=scr.y*.5
	screenres scr.x,scr.y,16,,1

	For i As Integer = 0 To 2
		scores.scoretable(i) = ImageCreate(scr.x/4,scr.y/4,black )
	Next
	openhighscores(scores)

	ingame.apple.size=7

	options.gamemode(0).title="ESCAPE"
	options.gamemode(1).title="SURVIVAL"
	options.gamemode(2).title="MAXRUN"

	options.gamemode(0).startbits=81
	options.gamemode(1).startbits=9
	options.gamemode(2).startbits=1

	options.gamemode_idn=0

	options.tackle=.9

end sub

Sub alllogic(byref player as playertype, byref scores as scorestype, byval scr as screentype, bitt() as bitstype, byref ingame as ingametype, byval options as optionstype)
    
ingame.restart = 0

ingame.appleexist=0

reinit(player, scr, bitt(), options)

Do
   
		if options.dc=-1 then draw_cursor(player,0, 0)
    moveyourself(player,scr)
		if options.dc=-1 then draw_cursor(player,rgb(100,250,100), 0)
	
    movebits(player, bitt(), ingame)
    
    if player.forcefield=-1 then
    	tiltbits(player, bitt(), ingame)
		player.forcefield=0
	end if

    If checkcollision(player.x , player.y, bitt(), ingame, options) Then 
        if player.oldcollision=-1 then endsub(player, scores, scr, options, ingame) 
        player.oldcollision=-1
    else
        player.oldcollision=0
    end if
   
    If checkescape(player.x,player.y,scr.hx,scr.hy) = -1 Then 
        endsub(player, scores, scr, options, ingame)
  	end if
   
    plotbits (bitt(), ingame)
   
    plotplayer (player)
   
    apples (player, scr, options, ingame)
   
    If options.gamemode_idn=1 Then
        ingame.surcounter+=1
        if ingame.surcounter>250 then
            ingame.surcounter=0
            ingame.totbits+=1
        End If
    End If
	
	sleep 4

Loop Until multikey(1) Or ingame.restart

End Sub

Sub endsub(byref player as playertype, byref scores as scorestype, byval scr as screentype, byval options as optionstype, byref ingame as ingametype)
dim as integer x,y,i
    
    do
	    getmouse player.con(0).x,player.con(0).y,,player.con(0).b
	loop while player.con(0).b<>0
    
    
        Locate 9,36
        If not checkescape (player.x , player.y, scr.hx, scr.hy) Then
            Color rgb(200,150,200)
            ? "CAPTURED"
            player.rings=0
            player.totrings=0
            ingame.totbits=options.gamemode(options.gamemode_idn).startbits
        else
            Color palegreen
            ? "ESCAPE!"
        end if
    
    if checkescape (player.x , player.y, scr.hx, scr.hy) then 
                
        player.totrings+=player.rings
        if player.totrings>player.bestrings then player.bestrings=player.totrings
        
        color gold
        x=0:y=0
        for i = 1 to player.bestrings
            y+=20
            x=20*int(y/600)
            circle (x+10,(y mod 600)+10),5
        next
        color cream
        x=0:y=0
        for i = 1 to player.totrings
            y+=20
            x=20*int(y/600)
            circle (x+10,(y mod 600)+10),5
        next
        
        If player.totrings > scores.highscore(options.gamemode_idn) Then 
		    scores.highscore(options.gamemode_idn) = player.totrings
        	bsavehigh(options.gamemode_idn, player, scores, scr)
		end if
		
		if options.gamemode_idn=2 then 
			player.totrings=0
			player.rings=0
			ingame.totbits=options.gamemode(options.gamemode_idn).startbits
		end if

    END IF

    Do

		sel_consel (player.con(0).x,player.con(0).y, player.con(0).b, 0)
       
        If multikey(1) Then ingame.quit=-1
       
        Sleep 1
    Loop Until player.con(0).b=1 Or _
    							ingame.quit=-1 or _
    							player.con(0).b=2
   
   ingame.restart =-1
    
   if player.con(0).b=2 then ingame.restart=-2
    
    do
		sel_consel (player.con(0).x,player.con(0).y, player.con(0).b, 0)
	    sleep 1
    loop while player.con(0).b<>0

    
End Sub

Sub setupbits(byval scr as screentype, bitt() as bitstype, byval options as optionstype)
dim as single distance , angle
dim as integer i

    For i = 1 To maxbits
        With bitt(i)
            angle = (Rnd*6.282)
            distance = Int(Rnd * (ovalsize*.5)) + .51*ovalsize
            .x = scr.hx - (Sin(angle) * distance)
            .y = scr.hy - (Cos(angle) * distance)
            
	        .scycle = -modlen
	        .ecycle = modlen
	        .guard=rnd
	        .spd=rnd*.8+.2
	        
	        if options.gamemode_idn=0 then .cycle=0
	        
            if .sign=0 then .sign = 1+(2*(rnd>.5))
	        
	        .colour=rgb(205,150+int(rnd*100),205)
	        
        End With
    Next
   
End Sub

Sub reinit(byref player as playertype, byval scr as screentype, bitt() as bitstype, byval options as optionstype)
       
    player.rings=0
    
    player.x = scr.hx : player.y = scr.hy
    player.oldx = scr.hx : player.oldy = scr.hy
    
    Cls
   
    Circle (scr.hx,scr.hy), ovalsize, rgb(0,int(rnd*55)+200,0)
   
    setupbits (scr, bitt(), options)

End Sub

Sub apples(byref player as playertype, byval scr as screentype, byval options as optionstype, byref ingame as ingametype)
dim as single mag , angle

    If ingame.appleexist = 0 Then
        do
            angle = Rnd * pi*2
            mag = (Rnd*ovalsize)-ovalsize*.1
            ingame.apple.x = scr.hx-Sin(angle)*mag
            ingame.apple.y = scr.hy-Cos(angle)*mag
        loop until sqr((ingame.apple.x-player.x)^2+(ingame.apple.y-player.y)^2) > ingame.apple.size
        ingame.appleexist = -1
        circle (ingame.apple.x,ingame.apple.y),ingame.apple.size,cream
    End If

    if sqr((player.x-ingame.apple.x)^2+(player.y-ingame.apple.y)^2) < ingame.apple.size+1 and _
											     ingame.appleexist = -1 then
        ingame.appleexist = 0 
        if options.gamemode_idn=0 then ingame.appleexist = -2
        
        circle (ingame.apple.x,ingame.apple.y),ingame.apple.size,black
        player.rings+=1
        If options.gamemode_idn<>1 Then ingame.totbits+=1
    End If
   
End Sub

sub initial_screen (byref player as playertype, byref scr as screentype, byval scores as scorestype, byref options as optionstype)
	sleep 200,1
	cls
    
    setmouse scr.hx,scr.hy,0
    
    Locate 1,30
    Color lightblue
    ? "bitrunner"
    Locate 2,14
    Color palegreen
    ? "collect and escape with as many rings as possible"
    Sleep 500,1
   
    Line (1,30)-(scr.x-1,50),rgb(255,0,0),b
    Locate 3,28
    Color cream
    ? "GAME MODE:"; options.gamemode(options.gamemode_idn).title
    Color rgb(150,150,150)
    Locate 5,14
    ? "use the mouse buttons inside the box to change game mode"

    Line (0,scr.hy-.3*scr.hy)-(scr.x,scr.hy-.3*scr.hy),rgb(0,250,0)
    locate 33,28
    color white
    ? "start"
    locate 36,21
    Color lightpink
    ? "left mouse button to continue, rmb for splashscreen"
    
    For i As Integer = 0 To 2
        Put (i*scr.x/3, scr.y-1/3*scr.y), scores.scoretable(i)
    Next

    Do
       	draw_cursor (player, black, 0)
        getmouse player.con(0).x , player.con(0).y , , player.con(0).b
       	draw_cursor (player, white, 0)
       	
		    If player.con(0).y < 50 And player.con(0).b <> 0 Then
		    	
		        Select Case player.con(0).b
		        Case 1
		        	options.gamemode_idn=0
		        Case 2
		        	options.gamemode_idn=2
		        Case 4
		        	options.gamemode_idn=1
		        End Select
		        Locate 3,38
		        Color cream
		        ? options.gamemode(options.gamemode_idn).title;"     "
		    End If
   
    locate 17,20
    ? "press 1 for cursor"
	if multikey(&h2) then 
		options.dc=(options.dc=0)
		locate 19,20
		? options.dc
	end if

    Sleep 20
    
    Loop Until player.con(0).b <> 0 and player.con(0).y > scr.hy-.3*scr.hy Or multikey(1)

end sub

